/* 
 * Enable DSL 2 syntax
 */
nextflow.enable.dsl = 2

//Channels
Channel
    .fromPath( params.fastq1 )
    .set { fastq1 }
Channel
    .fromPath( params.fastq2 )
    .set { fastq2 }

/*
 * Includes
 */ 
include {
    FASTQC
} from "./modules/fastqc"
include {
    FASTP
} from "./modules/fastp"
include {
    FASTQC as FASTQC_PRE_PROCESSED
} from "./modules/fastqc"

/*
* Subworkflow trimmed_fastq
* Quality Control (raw data), Raw Data trimming and Quality Control (pre-processed)
*/
workflow TRIMMED_FASTQ {    
    main:
        FASTQC(fastq1,
               fastq2,
               params.threads_fastqc)

        FASTP(fastq1,
              fastq2,
              params.threads_fastp,
              params.cut_right_window_size,
              params.cut_right_mean_quality,
              params.trim_tail1,
              params.length_required)
        
        FASTQC_PRE_PROCESSED(FASTP.out.paired_fastq1,
                FASTP.out.paired_fastq2,
                params.threads_fastqc)

}

workflow{
    TRIMMED_FASTQ()
}   